#------------------------------------------------------------------------------
# init_naph_pbtk_2c.R
#
# Author: Dustin Kapraun, US EPA, September 2019
#
# This script loads the napthalene PBTK model defined in the DLL file
# "naph_pbtk_2c.dll" (for Windows) or the SO file "naph_pbtk_2c.so" (for
# UNIX). The script also loads all functions defined in the files "RMCSim.R"
# and "human.R".
#------------------------------------------------------------------------------

# Load essential functions for working with MCSim models.
source("RMCSim.R")

# Load the relevant model.
model_name = "naph_pbtk_2c"
load_model(model_name)

# Load a function that can be called to parameterize the relevant model for
# humans.
source("human.R")