initParms <- function(newParms = NULL) {
  parms <- c(
    AEXP = 0.0,
    VWELL = 1.0,
    BWinit = 315,
    QPUc = 1.756,
    MVc = 1.909,
    DSC = 1.0e-8,
    TSC = 0.003,
    TVE = 0.0075,
    FBURT = 0.0015,
    FBLI = 0.25,
    FBFA = 0.07,
    FBPP = 0.1675,
    FBRP = 0.5,
    FBCA = 0.011,
    FTLI = 0.037,
    FFAT = 0.065,
    FTPP = 0.5618,
    FTRP = 0.178,
    FTABD = 0.018,
    FTVBD = 0.045,
    FTREM = 0.09,
    HBA = 571.0,
    HTB = 3.49,
    HLUB = 1.71,
    HLB = 1.61,
    HFB = 49.0,
    HRPB = 2.12,
    HPPB = 3.49,
    HVEB = 2.73,
    HSCVE = 1.98,
    HSCJP8 = 1.0,
    SADR = 0.2,
    SADO1 = 0.42,
    SADO2 = 6.33,
    SAVR1 = 1.8,
    SAVR2 = 4.5,
    SAPL = 1.5,
    SACA = 48.0,
    SAPU = 3000.0,
    WTDR = 0.005,
    WTDO = 0.005,
    WTVR = 0.005,
    WTPL = 0.005,
    WTCA = 0.005,
    WTPU = 0.0004,
    WMUCUS = 0.001,
    WXDR = 0.002,
    WXDO = 0.002,
    WXVR = 0.002,
    WXPL = 0.002,
    WXCA = 0.002,
    VLDR = 0.004,
    VLDO1 = 0.012,
    VLDO2 = 0.054,
    VLVR1 = 0.09,
    VLVR2 = 0.09,
    VLPL = 0.06,
    VLCA = 0.53,
    KGDR = 8000.0,
    KGDO1 = 7167.0,
    KGDO2 = 26667.0,
    KGVR1 = 34680.0,
    KGVR2 = 183333.0,
    KGPL = 5000.0,
    KGCA = 225.0,
    DIFU = 4.5e-4,
    MW1 = 128.17,
    PPMtoNMPML = 0.04,
    VmaxLI = 21.8,
    KmLI = 6.0,
    VmaxLU = 3.8,
    KmLU = 40.0,
    VmaxO = 169.8,
    KmO = 70.0,
    VmaxV = 43.5,
    KmV = 11.5,
    FADR = 0.15,
    FADO = 0.15,
    FAVR = 0.85,
    VTDR = 0.0,
    VTDO1 = 0.0,
    VTDO2 = 0.0,
    VTVR1 = 0.0,
    VTVR2 = 0.0,
    VTPL = 0.0,
    VTCA = 0.0,
    VTPU = 0.0,
    VXDR = 0.0,
    VXDO1 = 0.0,
    VXDO2 = 0.0,
    VXVR1 = 0.0,
    VXVR2 = 0.0,
    VXPL = 0.0,
    VXCA = 0.0,
    VTLUNG = 0.0,
    SAURT = 0.0,
    VTLI = 0.0,
    VFAT = 0.0,
    VTSC = 0.0,
    VTVE = 0.0,
    VTRP = 0.0,
    VTPP = 0.0,
    VTAB = 0.0,
    VTVB = 0.0,
    VTREM = 0.0,
    SCDX = 0.0,
    BW = 0.0,
    MV = 0.0,
    VPU = 0.0,
    VDR = 0.0,
    VDO = 0.0,
    VVR = 0.0,
    QPUa = 0.0,
    FBDR = 0.0,
    FBDO1 = 0.0,
    FBDO2 = 0.0,
    FBVR1 = 0.0,
    FBVR2 = 0.0,
    FBPL = 0.0,
    QDR = 0.0,
    QDO1 = 0.0,
    QDO2 = 0.0,
    QVR1 = 0.0,
    QVR2 = 0.0,
    QPL = 0.0,
    QCA = 0.0,
    QLI = 0.0,
    QVE = 0.0,
    QRP = 0.0,
    QPP = 0.0,
    QFA = 0.0,
    QPU = 0.0,
    HTA = 0.0,
    MTCDR = 0.0,
    MTCDO1 = 0.0,
    MTCDO2 = 0.0,
    MTCVR1 = 0.0,
    MTCVR2 = 0.0,
    MTCPL = 0.0,
    MTCCA = 0.0,
    KTXDR = 0.0,
    KTXDO1 = 0.0,
    KTXDO2 = 0.0,
    KTXVR1 = 0.0,
    KTXVR2 = 0.0,
    KTXPL = 0.0,
    KTXCA = 0.0
  )

  if (!is.null(newParms)) {
    if (!all(names(newParms) %in% c(names(parms)))) {
      stop("illegal parameter name")
    }
    parms[names(newParms)] <- newParms
  }

  parms <- within(as.list(parms), {
  })
  out <- .C("getParms",  as.double(parms),
            out=double(length(parms)),
            as.integer(length(parms)))$out
  names(out) <- names(parms)
  out
}

Outputs <- c(
    "ASC",
    "CWELL",
    "CSC00",
    "CSC10",
    "CLDR",
    "CTDR",
    "CXDR",
    "CLDO1",
    "CTDO1",
    "CXDO1",
    "CLDO2",
    "CTDO2",
    "CXDO2",
    "CLVR1",
    "CTVR1",
    "CXVR1",
    "CURT",
    "CLPL",
    "CTPL",
    "CXPL",
    "CLCA",
    "CTCA",
    "CXCA",
    "CLPU",
    "CTPU",
    "CvTPU",
    "CLI",
    "CvLI",
    "CFA",
    "CvFA",
    "CRP",
    "CvRP",
    "CPP",
    "CvPP",
    "CVE",
    "CvVE",
    "CAB",
    "CVB",
    "CAB_UG",
    "JSC00",
    "JSC10",
    "AINa",
    "CTDO",
    "CTDO_UG",
    "RCMTDO_UG",
    "RCMBODY_UG",
    "RDELDO_UG"
)

initStates <- function(parms, newStates = NULL) {
  Y <- c(
    RIV = 0.0,
    AIV = 0.0,
    CIN = 0.0,
    AWELL = 0.0,
    CSC01 = 0.0,
    CSC02 = 0.0,
    CSC03 = 0.0,
    CSC04 = 0.0,
    CSC05 = 0.0,
    CSC06 = 0.0,
    CSC07 = 0.0,
    CSC08 = 0.0,
    CSC09 = 0.0,
    ADERM = 0.0,
    ALDR = 0.0,
    AMTDR = 0.0,
    ATDR = 0.0,
    AXDR = 0.0,
    ALDO1 = 0.0,
    AMTO1 = 0.0,
    ATDO1 = 0.0,
    AXDO1 = 0.0,
    ALDO2 = 0.0,
    AMTO2 = 0.0,
    ATDO2 = 0.0,
    AXDO2 = 0.0,
    ALVR1 = 0.0,
    AMTV1 = 0.0,
    ATVR1 = 0.0,
    AXVR1 = 0.0,
    ALVR2 = 0.0,
    AMTV2 = 0.0,
    ATVR2 = 0.0,
    AXVR2 = 0.0,
    ALPL = 0.0,
    ATPL = 0.0,
    AXPL = 0.0,
    ALCA = 0.0,
    ATCA = 0.0,
    AXCA = 0.0,
    AMLPU = 0.0,
    ATPU = 0.0,
    AML = 0.0,
    ALI = 0.0,
    AFA = 0.0,
    ARP = 0.0,
    APP = 0.0,
    AVE = 0.0,
    AAB = 0.0,
    AVB = 0.0,
    AIN = 0.0,
    AUC_CAB_UG = 0.0,
    AUC_CTDO_UG = 0.0,
    CMTDO_UG = 0.0,
    AUC_CMTDO_UG = 0.0,
    AUC_RCMTDO_UG = 0.0,
    CMBODY_UG = 0.0,
    AUC_CMBODY_UG = 0.0,
    AUC_RCMBODY_UG = 0.0,
    CTDOALT_UG = 0.0,
    AUC_CTDOALT_UG = 0.0,
    AUC_RDELDO_UG = 0.0
  )

  Y <- within(c(as.list(parms),as.list(Y)), {
    Y["RIV"] <- 0.0 
    Y["AIV"] <- 0.0 
    Y["CIN"] <- 0.0 
    Y["AWELL"] <- 0.0 
    Y["CSC01"] <- 0.0 
    Y["CSC02"] <- 0.0 
    Y["CSC03"] <- 0.0 
    Y["CSC04"] <- 0.0 
    Y["CSC05"] <- 0.0 
    Y["CSC06"] <- 0.0 
    Y["CSC07"] <- 0.0 
    Y["CSC08"] <- 0.0 
    Y["CSC09"] <- 0.0 
    Y["ADERM"] <- 0.0 
    Y["ALDR"] <- 0.0 
    Y["AMTDR"] <- 0.0 
    Y["ATDR"] <- 0.0 
    Y["AXDR"] <- 0.0 
    Y["ALDO1"] <- 0.0 
    Y["AMTO1"] <- 0.0 
    Y["ATDO1"] <- 0.0 
    Y["AXDO1"] <- 0.0 
    Y["ALDO2"] <- 0.0 
    Y["AMTO2"] <- 0.0 
    Y["ATDO2"] <- 0.0 
    Y["AXDO2"] <- 0.0 
    Y["ALVR1"] <- 0.0 
    Y["AMTV1"] <- 0.0 
    Y["ATVR1"] <- 0.0 
    Y["AXVR1"] <- 0.0 
    Y["ALVR2"] <- 0.0 
    Y["AMTV2"] <- 0.0 
    Y["ATVR2"] <- 0.0 
    Y["AXVR2"] <- 0.0 
    Y["ALPL"] <- 0.0 
    Y["ATPL"] <- 0.0 
    Y["AXPL"] <- 0.0 
    Y["ALCA"] <- 0.0 
    Y["ATCA"] <- 0.0 
    Y["AXCA"] <- 0.0 
    Y["ATPU"] <- 0.0 
    Y["AMLPU"] <- 0.0 
    Y["ALI"] <- 0.0 
    Y["AML"] <- 0.0 
    Y["AFA"] <- 0.0 
    Y["ARP"] <- 0.0 
    Y["APP"] <- 0.0 
    Y["AVE"] <- 0.0 
    Y["AAB"] <- 0.0 
    Y["AVB"] <- 0.0 
    Y["AIN"] <- 0.0 
    Y["AUC_CAB_UG"] <- 0.0 
    Y["AUC_CTDO_UG"] <- 0.0 
    Y["CMTDO_UG"] <- 0.0 
    Y["AUC_CMTDO_UG"] <- 0.0 
    Y["AUC_RCMTDO_UG"] <- 0.0 

    Y["CMBODY_UG"] <- 0.0 
    Y["AUC_CMBODY_UG"] <- 0.0 
    Y["AUC_RCMBODY_UG"] <- 0.0 

    Y["CTDOALT_UG"] <- 0.0 
    Y["AUC_CTDOALT_UG"] <- 0.0 
    Y["AUC_RDELDO_UG"] <- 0.0 

  })$Y

  if (!is.null(newStates)) {
    if (!all(names(newStates) %in% c(names(Y)))) {
      stop("illegal state variable name in newStates")
    }
    Y[names(newStates)] <- newStates
  }

.C("initState", as.double(Y));
Y
}
